Index: trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 716)
@@ -8,21 +8,21 @@
   implicit none
 
-!==================================================================
-!     
-!     Purpose
-!     -------
-!     Run the universal model radiative transfer once in a 1D column.
-!     Useful for climate evolution studies etc.
-!     
-!     It can be compiled with a command like (e.g. for 25 layers):
-!                                  "makegcm -p std -d 25 kcm1d"
-!     It requires the files "callphys.def", "gases.def"
-!     "traceur.def", and "run.def" with a line "INCLUDEDEF=callphys.def"
-!
-!     Authors
-!     -------
-!     R. Wordsworth
-!
-!==================================================================
+  !==================================================================
+  !     
+  !     Purpose
+  !     -------
+  !     Run the universal model radiative transfer once in a 1D column.
+  !     Useful for climate evolution studies etc.
+  !     
+  !     It can be compiled with a command like (e.g. for 25 layers):
+  !                                  "makegcm -p std -d 25 kcm1d"
+  !     It requires the files "callphys.def", "gases.def"
+  !     "traceur.def", and "run.def" with a line "INCLUDEDEF=callphys.def"
+  !
+  !     Authors
+  !     -------
+  !     R. Wordsworth
+  !
+  !==================================================================
 
 #include "dimensions.h"
@@ -35,7 +35,7 @@
 #include "advtrac.h"
 
-! --------------------------------------------------------------
-!  Declarations
-! --------------------------------------------------------------
+  ! --------------------------------------------------------------
+  !  Declarations
+  ! --------------------------------------------------------------
 
   integer nlayer,nlevel,nq
@@ -61,6 +61,6 @@
   real fluxabs_sw    ! SW flux absorbed by planet (W/m2)
   real fluxtop_dn    ! incident top of atmosphere SW flux (W/m2)
-      
-! not used
+
+  ! not used
   real reffrad(nlayermx,naerkind)
   real nueffrad(nlayermx,naerkind)
@@ -71,14 +71,14 @@
   real dTstrat
   real aerosol(nlayermx,naerkind) ! aerosol tau (kg/kg)
-  real OLR_nu(L_NSPECTI)
-  real GSR_nu(L_NSPECTV)
+  real OLR_nu(ngridmx,L_NSPECTI)
+  real OSR_nu(ngridmx,L_NSPECTV)
   real Eatmtot
 
   integer ierr
-  logical firstcall,lastcall
-
-! --------------
-! Initialisation
-! --------------
+  logical firstcall,lastcall,global1d
+
+  ! --------------
+  ! Initialisation
+  ! --------------
 
   pi=2.E+0*asin(1.E+0)
@@ -89,13 +89,18 @@
   totcloudfrac  = 0.0
 
-!  Load parameters from "run.def" 
-! -------------------------------
-
-! check if 'run1d.def' file is around (otherwise reading parameters
-! from callphys.def via getin() routine won't work.)
-  open(90,file='run.def',status='old',form='formatted',&
+
+  nlayer=nlayermx
+  nlevel=nlayer+1
+
+
+  !  Load parameters from "run.def" 
+  ! -------------------------------
+
+  ! check if 'kcm1d.def' file is around (otherwise reading parameters
+  ! from callphys.def via getin() routine won't work.)
+  open(90,file='kcm1d.def',status='old',form='formatted',&
        iostat=ierr)
   if (ierr.ne.0) then
-     write(*,*) 'Cannot find required file "run.def"'
+     write(*,*) 'Cannot find required file "kcm1d.def"'
      write(*,*) '  (which should contain some input parameters'
      write(*,*) '   along with the following line:'
@@ -108,6 +113,28 @@
   endif
 
-  nlayer=nlayermx
-  nlevel=nlayer+1
+! now, run.def is needed anyway. so we create a dummy temporary one
+! for ioipsl to work. if a run.def is already here, stop the
+! program and ask the user to do a bit of cleaning
+  open(90,file='run.def',status='old',form='formatted',& 
+       iostat=ierr)
+  if (ierr.eq.0) then
+     close(90)
+     write(*,*) 'There is already a run.def file.'
+     write(*,*) 'This is not compatible with 1D runs.'
+     write(*,*) 'Please remove the file and restart the run.'
+     write(*,*) 'Runtime parameters are supposed to be in kcm1d.def'
+     stop
+  else
+     call system('touch run.def')
+     call system("echo 'INCLUDEDEF=callphys.def' >> run.def")
+     call system("echo 'INCLUDEDEF=kcm1d.def' >> run.def")
+  endif
+
+  global1d = .false. ! default value
+  call getin("global1d",global1d)
+  if(.not.global1d)then
+     print*,'Error, kcm1d must have global1d=.true. in kcm1d.def!'
+     stop
+  end if
 
   psurf_n=100000. ! default value for psurf
@@ -115,5 +142,9 @@
   call getin("psurf",psurf_n)
   write(*,*) " psurf = ",psurf_n
-      
+
+! OK. now that run.def has been read once -- any variable is in memory.
+! so we can dump the dummy run.def
+  call system("rm -rf run.def")
+
   tsurf=300.0 ! default value for tsurf
   print*,'Surface temperature (K)?'
@@ -125,5 +156,5 @@
   call getin("g",g)
   write(*,*) " g = ",g
-  
+
   periastr = 1.0
   apoastr  = 1.0
@@ -136,5 +167,5 @@
   call getin("apoastr",apoastr)
   write(*,*) "apoastron = ",apoastr
- 
+
   albedo=0.2 ! default value for albedo
   print*,'Albedo of bare ground?'
@@ -155,12 +186,19 @@
   cpp=0.
 
+  check_cpp_match = .false.
+  call getin("check_cpp_match",check_cpp_match)
+  if (check_cpp_match) then
+     print*,"In 1D modeling, check_cpp_match is supposed to be F"
+     print*,"Please correct callphys.def"
+     stop
+  endif
+
   call su_gases
   call calc_cpp_mugaz
 
-
   call inifis(1,llm,0,86400.0,1.0,0.0,0.0,1.0,rad,g,r,cpp)
 
-! Tracer initialisation
-! ---------------------
+  ! Tracer initialisation
+  ! ---------------------
   if (tracer) then
      ! load tracer names from file 'traceur.def'
@@ -183,5 +221,5 @@
            endif
         endif
-        
+
         do iq=1,nq
            ! minimal version, just read in the tracer names, 1 per line
@@ -193,7 +231,6 @@
         enddo !of do iq=1,nq
      endif
-  !endif
-  
-  call initracer()
+
+     call initracer()
 
   endif
@@ -205,5 +242,5 @@
      enddo
   enddo
-  
+
   do iq=1,nqmx
      qsurf(iq) = 0.
@@ -214,26 +251,26 @@
 
   iter    = 1
-  Tstrat  = 60.0
+  Tstrat  = 150.0
   dTstrat = 1000.0
 
-! ---------
-! Run model
-! ---------
-  do
+  ! ---------
+  ! Run model
+  ! ---------
+  !do
      psurf = psurf_n
 
-!    Create vertical profiles
+     !    Create vertical profiles
      call kcmprof_fn(psurf,qsurf(1),tsurf,    &
           tstrat,play,plev,zlay,temp,q(:,1),muvar(1))
 
-!    Run radiative transfer
+     !    Run radiative transfer
      call callcorrk(ngridmx,nlayer,q,nqmx,qsurf,      &
           albedo,emis,mu0,plev,play,temp,                    &
-          tsurf,fract,dist_star,aerosol,cpp,muvar,         &
+          tsurf,fract,dist_star,aerosol,muvar,         &
           dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
-          fluxabs_sw,fluxtop_dn,reffrad,tau_col,  &
+          fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,reffrad,tau_col,  &
           cloudfrac,totcloudfrac,.false.,firstcall,lastcall)
- 
-!    Iterate stratospheric temperature
+
+     !    Iterate stratospheric temperature
      print*,'Tstrat = ',Tstrat
      dTstrat = Tstrat
@@ -244,26 +281,38 @@
      dTstrat = dTstrat-Tstrat
 
-     if(abs(dTstrat).lt.1.0)then
-        print*,'dTstrat = ',dTstrat
-        exit
-     endif
-
-     iter=iter+1
-     if(iter.eq.100)then
-        print*,'Stratosphere failed to converge after'
-        print*,'100 iteration, aborting run.'
-        call abort
-     endif
-
-  end do
-
-! Calculate total atmospheric energy
+     !if(abs(dTstrat).lt.1.0)then
+     !   print*,'dTstrat = ',dTstrat
+     !   exit
+     !endif
+
+     !iter=iter+1
+     !if(iter.eq.100)then
+     !   print*,'Stratosphere failed to converge after'
+     !   print*,'100 iteration, aborting run.'
+     !   call abort
+     !endif
+
+  !end do
+
+  ! Run radiative transfer one last time to get OLR,OSR
+  firstcall=.false.
+  lastcall=.true.
+  call callcorrk(ngridmx,nlayer,q,nqmx,qsurf,      &
+       albedo,emis,mu0,plev,play,temp,                    &
+       tsurf,fract,dist_star,aerosol,muvar,         &
+       dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
+       fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,             &
+       reffrad,tau_col,  &
+       cloudfrac,totcloudfrac,.false.,firstcall,lastcall)
+
+
+  ! Calculate total atmospheric energy
   Eatmtot=0.0
-!  call calcenergy_kcm(tsurf,temp,play,plev,qsurf,&
-!     q(:,1),muvar,Eatmtot)
-
-! ------------------------
-! Save data to ascii files
-! ------------------------
+  !  call calcenergy_kcm(tsurf,temp,play,plev,qsurf,&
+  !     q(:,1),muvar,Eatmtot)
+
+  ! ------------------------
+  ! Save data to ascii files
+  ! ------------------------
 
   print*,'Saving profiles...'
@@ -293,4 +342,6 @@
   close(119)
 
+  print*, tsurf,psurf,fluxtop_dn,fluxabs_sw,fluxtop_lw 
+
   print*,'Saving scalars...'
   open(116,file='surf_vals.out')
@@ -305,11 +356,11 @@
   open(117,file='OLRnu.out')
   do iw=1,L_NSPECTI
-     write(117,*) OLR_nu(iw)
+     write(117,*) OLR_nu(1,iw)
   enddo
   close(117)
-  
-  open(127,file='GSRnu.out')
+
+  open(127,file='OSRnu.out')
   do iw=1,L_NSPECTV
-     write(127,*) GSR_nu(iw)
+     write(127,*) OSR_nu(1,iw)
   enddo
   close(127)  
Index: trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90	(revision 716)
@@ -40,7 +40,5 @@
   double precision Dz, Dp
   double precision Ptop, dlogp, Psat_max
-  parameter (Ptop=1.0)           ! Pressure at TOA [Pa]
-  !parameter (Psat_max=100000.0) ! Maximum vapour pressure [Pa]
-  parameter (Psat_max=0.0) ! set to zero for dry calculations
+  parameter (Ptop=1.0)                             ! Pressure at TOA [Pa]
 
   double precision T(1:nlay)                       ! temperature [K]
@@ -64,6 +62,7 @@
   double precision psat_v      ! local Psat_H2O value
   double precision Tcrit       ! Critical temperature [K]
-!  double precision Tsat        ! local Tsat_H2O value
   double precision rho_vTEMP,rho_nTEMP
+
+  double precision TCO2cond ! for CO2 condensation quasi-hack
 
   ! variables necessary for steam.f90
@@ -74,5 +73,8 @@
 
   logical verbose
-  parameter(verbose=.false.)
+  parameter(verbose=.true.)
+
+  logical add_Pvar_to_total
+  parameter(add_Pvar_to_total=.true.)
 
   ! initialise flags
@@ -82,24 +84,26 @@
   ! assign input variables
   m_n     = dble(mugaz/1000.)
+  cp_n    = cpp
   ! modify/generalise later??
 
-  if(ngasmx.gt.2)then
-     print*,'Only two species possible at present'
-     stop
-  elseif(ngasmx.eq.1)then
+  Psat_max = 1000000.0 ! maximum vapour pressure [Pa]
+                       ! set huge until further notice 
+
+  if(vgas.lt.1)then
      if(psat_max.gt.0.0)then
         print*,'Must have Psat_max=0 if no variable species'
-        stop
+        psat_max=0.0
+        !stop
      endif
      print*, 'Assuming pure atmosphere'
      m_v   = 1.0
      tcrit = 1000.0
-  elseif(gnom(ngasmx).eq.'H2O')then
+  elseif(gnom(vgas).eq.'H2O')then
      m_v   = dble(mH2O/1000.)
      tcrit = 6.47d2
-  elseif(gnom(ngasmx).eq.'NH3')then
+  elseif(gnom(vgas).eq.'NH3')then
      m_v   = 17.031/1000.
      tcrit = 4.06d2
-  elseif(gnom(ngasmx).eq.'CH4')then
+  elseif(gnom(vgas).eq.'CH4')then
      m_v   = 16.04/1000.
      tcrit = 1.91d2
@@ -111,24 +115,14 @@
 
   rmn     = rc/m_n
-  
-  Psurf_n = dble(psurf_rcm)
   Ttop    = dble(Tstra_rcm)
   Tsurf   = dble(Tsurf_rcm)
 
-
-  ! assume vapour saturation at surface (for now)
-!  if (tsurf > tcrit) then
-!     print*,'Above critical temperature for ',gnom(2),&
-!          ', at surface, assuming 10 bar pressure instead'
-!     Psurf_v = 10*1d5
-!     profil_flag(1) = 0
-!i!  endif
-
-
-  psat_v=psat_max
-  if(gnom(ngasmx).eq.'H2O')then
-     call Psat_H2O(tsurf,psat_v)
-  elseif(gnom(ngasmx).eq.'NH3')then
-     call Psat_NH3(tsurf,psat_v)
+  psat_v  = psat_max
+  if(vgas.gt.0)then
+     if(gnom(vgas).eq.'H2O')then
+        call Psat_H2O(tsurf,psat_v)
+     elseif(gnom(vgas).eq.'NH3')then
+        call Psat_NH3(tsurf,psat_v)
+     endif
   endif
 
@@ -142,5 +136,16 @@
   endif
 
-
+  if(add_Pvar_to_total)then
+    Psurf_n = dble(psurf_rcm)
+    psurf_rcm = real(Psurf_n+Psurf_v)
+  else
+    Psurf_n = dble(psurf_rcm) - Psurf_v
+  endif
+
+  ! include relative humidity option
+  !if(satval.lt.1.0)then
+  !   Psurf_v = Psurf_v*satval
+  !   profil_flag(1) = 0     
+  !endif
 
   if(verbose)then
@@ -155,8 +160,5 @@
   endif
 
-
-
   ! define fine pressure grid
-  psurf_rcm = real(Psurf_n+Psurf_v)
   dlogp_rcm = -(log(psurf_rcm)-log(ptop))/nlayermx
 
@@ -207,7 +209,4 @@
   do ilay=2,nlay-1
 
-
-
-
      ! calculate altitude levels (for diagnostic only)
      Dz         = -Dp/(  g*(rho_n(ilay) + rho_v(ilay))  )
@@ -228,8 +227,11 @@
      ! test for moist adiabat at next level
      psat_v=psat_max
-     if(gnom(ngasmx).eq.'H2O')then
+
+     if(vgas.gt.0)then
+     if(gnom(vgas).eq.'H2O')then
         call Psat_H2O(T(ilay+1),psat_v)
-     elseif(gnom(ngasmx).eq.'NH3')then
+     elseif(gnom(vgas).eq.'NH3')then
         call Psat_NH3(T(ilay+1),psat_v)
+     endif
      endif
 
@@ -253,8 +255,11 @@
        
         psat_v=psat_max 
-        if(gnom(ngasmx).eq.'H2O')then
+
+        if(vgas.gt.0)then
+        if(gnom(vgas).eq.'H2O')then
            call Psat_H2O(T(ilay+1),psat_v)
-        elseif(gnom(ngasmx).eq.'NH3')then
+        elseif(gnom(vgas).eq.'NH3')then
            call Psat_NH3(T(ilay+1),psat_v)
+        endif
         endif
 
@@ -281,17 +286,4 @@
      end select
 
-
-
-!         print*,'profil_flag=',profil_flag(ilay)
-!         print*,'T=',T(ilay)
-!         print*,'a=',rho_v(ilay)/rho_n(ilay)
-!      if(profil_flag(ilay).eq.1)then
-!           stop
-!     endif
-
-
-
-
-
   enddo
 
@@ -378,4 +370,22 @@
   enddo
 
+!    CO2 condensation 'haircut' of temperature profile if necessary
+  if(co2cond)then
+     print*,'CO2 condensation haircut - assumes CO2-dominated atmosphere!'
+     do ilay=2,nlayermx
+        if(P_rcm(ilay).lt.518000.)then
+           TCO2cond = (-3167.8)/(log(.01*P_rcm(ilay))-23.23) ! Fanale's formula
+        else
+           TCO2cond = 684.2-92.3*log(P_rcm(ilay))+4.32*log(P_rcm(ilay))**2 
+           ! liquid-vapour transition (based on CRC handbook 2003 data)
+        endif
+
+        print*,'p=',P_rcm(ilay),', T=',T_rcm(ilay),' Tcond=',TCO2cond
+        if(T_rcm(ilay).lt.TCO2cond)then
+           T_rcm(ilay)=TCO2cond
+        endif
+     enddo
+  endif
+
   return
 end subroutine kcmprof_fn
